Subject: Re: The 'subdir-object' option breaks makefiles where foo_SOURCES contains $(var)

From: Harlan Stenn <[email-masked]>
Date: Fri, 02 Jan 2015 12:04:16 +0000

Stefano Lattarini writes:
> On 01/02/2015 02:16 AM, Harlan Stenn wrote:
> > Excellent timing, thanks!
> >
> > Now that ntp-4.2.8 is settling down, I'm looking to update our
> > Makefile.am's to use subdir-objects, and it's not being fun.
>
> (An aside: I see that ntp still uses a recursive Makefile setup.
> Given that you are about to mess with the ntp build system anyway,
> have you thought about trying to convert it to a non-recursive
> make setup?  That is the suggested way to go nowadays...)

I'd *love* to go non-recursive.  I've tried before, and haven't been
able to make it work.  The documentation wasn't there before, and my
brain didn't "see" what the new paradigm was trying to do.

> > I may wait until 1.15 is released to continue this effort.
>
> Well, actually, Automake 1.15 is already tagged in the Git repository
> and ready to be released (as soon as my new GPG key, replacing the one
> that expired 2 months ago, will be accepted by [email-masked]).
> So this patch will not be available before Automake 1.16.  But then
> again, I believe the fix for this bug alone would be enough to
> justify a new minor Automake release, so don't worry, this fix will
> go in some release soon enough :-)

Fair enough, thanks!

> Also, more importantly, notice that this patch do not yet solve the
> issue of '.deps' directories and object files being created in the
> source directory (rather than in the build directory) for source
> files that contains an explicit reference to $(srcdir), when the
> 'subdir-object' option is enabled; see the still XFAIL'ing test
> 't/subobj-vpath-pr13928.sh'.

I'm likely seeing that problem too.

> This issue should *hopefully* be easy to fix, especially with the
> new dependency-bootstrapping logic; and I will try hard to make
> that happen before the 1.16 release.

Cool, thanks!

H